(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.graphql_to_json = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
const converter = require('./lib/converter');

module.exports = converter;

},{"./lib/converter":3}],2:[function(require,module,exports){
module.exports = function CustomObject(obj) {
  return {
    _head: obj,
    _parents: [],
    current: obj,
    addcurr(name) {
      if (typeof this.current[name] === 'undefined') this.current[name] = {};
      this.in(name);
    },
    head() {
      this._parents = [];
      return this.current = this._head;
    },
    in(name) {
      this._parents.push(this.current);
      return this.current = this.current[name]
    },
    out() {
      if (this._parents.length > 0)
        return this.current = this._parents.pop();
      else
        return this.current;
    },
  };
}

},{}],3:[function(require,module,exports){
const lexer = require('./lexer');
const parser = require('./parser');

module.exports = function convert(data) {
  const tokens = lexer(data);
  return parser(tokens);
}

},{"./lexer":4,"./parser":5}],4:[function(require,module,exports){
const SINGLE = 0, BUFFERING = 1;

function isWhitespace (c) {
    return c === ' ' || c === '\n' || c === '\r' || c === '\t'
}

function isLetter(str) {
    return str.length === 1 && str.match(/[a-z]/i);
}

module.exports = function (data) {
    let i = 0, c = data[i], buffer = '', mode = SINGLE, currname, ignore = false;

    const result = [];

    function pushboth() {
        if (buffer) result.push(buffer);
        result.push(c);
        buffer = '';
        mode = SINGLE;
    }

    while (true) {
        if (i === data.length) break;
        
        if (c === '#') ignore = true;

        if (!ignore) {
            switch(mode) {
                case SINGLE:
                    if (isWhitespace(c)) break;
                    if (isLetter(c)) {
                        buffer += c;
                        mode = BUFFERING;
                        break;
                    }
                case BUFFERING:
                    if(c === '{') {
                        result.push(c);
                    } else if (c === '}') {
                        result.push(c);
                    } else if (c === ':') {
                        pushboth();
                    } else if (c === '!') {
                        pushboth();
                    } else if (c === '(') {
                        pushboth();
                    } else if (c === ')') {
                        pushboth();
                    } else {
                        if (isWhitespace(c)) {
                            if (buffer) result.push(buffer);
                            buffer = '';
                            mode = SINGLE;
                            break;
                        }
                        buffer += c;
                    }
            }
        } else {
            if (c === '\n') ignore = false;
        }
        
        i++;
        c = data[i];
    }
    return result;
}

},{}],5:[function(require,module,exports){
const CustomObject = require('./CustomObject');

const defs = ['type', 'input', 'schema', 'subscription'];
const TYPE_COMING = 0;
const INPUT_COMING = 1;
const rg_isArray = /[\]\[]/g;

module.exports = function (data) {
    let i = 0, item = data[i], tmp = null, mode = null;

    const json = CustomObject({});

    function next() {
        i++;
        item = data[i];
    }

    function nested(json) {
        while (true) {
            next();
 
            if (item === '}') return;
            else if (item === '{') {
                tmp = null;
                nested(json);
            }
            else if (item === '(') {
                json.addcurr('args');
            }
            else if (item === ')') {
                json.out();
            }
            else if (item === ':') mode = TYPE_COMING;
            else if (mode === TYPE_COMING) {
                json.current.type = item.replace(rg_isArray, '');
                json.current.array = item.match(rg_isArray) ? true : false;
                json.current.required = false;
                tmp = json.current;
                mode = null;
                json.out();
            }
            else if (item === '!') {
                tmp.required = true;
            }
            // add property name
            else {
                json.addcurr(item);
            }
        }
    }

    while (true) {
        if (i === data.length) break;

        if (defs.includes(item)) {
            json.head();
            json.addcurr(item);
        } else if (item === '{') {
            nested(json);
        } else {
            json.addcurr(item);
        }
        next();
    }
    return json.head();
}

},{"./CustomObject":2}]},{},[1])(1)
});
